clear all;
%
% Dataset downloaded from www.wiley.co.uk/baltagi/
A=xlsread('Panel_Jalisco.xls');
% Spatial weights matrix constructed by Elhorst
Reina=xlsread('Guadalajara_gal.xls');
SMtrx=spconvert(Reina);
W1=full(SMtrx);
%
% written by: J.Paul Elhorst summer 2008
% University of Groningen
% Department of Economics
% 9700AV Groningen
% the Netherlands
% j.p.elhorst@rug.nl
%
% REFERENCES: 
% Elhorst J.P. (2008) Serial and spatial autocorrelation. Economics Letters
% http://dx.doi.org/10.1016/j.econlet.2008.03.009
% -------------------------------------------------------------------------
% dimensions of the problem
T=2; % number of time periods
N=122; % number of regions
% row-normalize W
W=normw(W1); % function of LeSage
y=A(:,[8]); % column number in the data matrix that corresponds to the dependent variable
x=A(:,[9]); % column numbers in the data matrix that correspond to the independent variables
xconstant=ones(N*T,1);

% serial and spatial error correlation, including logpn variable
% one constraint on the paramaters active
vnames=strvcat('TCFI','Constant','LFI');
serialspatial(y,[xconstant x],W,N,T,vnames);

% serial and spatial error correlation, without logpn variable
% no constraint active, numerical problems with one of the t-values
x=A(:,[8]); % column numbers in the data matrix that correspond to the independent variables
vnames=strvcat('TCFI','Constant','LFI');
serialspatial(y,[xconstant x],W,N,T,vnames);